
module average 

	//////////////////PARAMETERS///////////////////////////

#(
	parameter 
	DATA_SIZE_BITS = 16
)

	//////////////////INPUTS AND OUTPUTS////////////////////

(
	input  [DATA_SIZE_BITS-1:0] IN_max,
	input  [DATA_SIZE_BITS-1:0] IN_min, 
	output [DATA_SIZE_BITS-1:0] OUT
);

	//////////////////WIRES////////////////////////////////

	wire signed [DATA_SIZE_BITS:0] sum;

	//////////////////COMBINATORIAL////////////////////////

	assign sum = $signed(IN_max) + $signed(IN_min);
	assign OUT = sum[0] ?  (sum >>> 1) + 1 : (sum >>> 1) ;	

endmodule
