
module feeder_cubic_spline_tb();


parameter DATA_SIZE_BITS = 16; 
parameter MAX_DIST_BIT = 8;
parameter DEPTH = 9;	
parameter EXTENTION_BITS = 8;
parameter PRECISION_BITS = 8;


reg clk, spline_finished, rst_n, point_is_extreme;
reg [DATA_SIZE_BITS-1:0] extremes;
reg first, data_in_available;
reg last;
wire last_out, first_out;
wire data_out_available;
wire [DATA_SIZE_BITS-1:0] cubic_spline_out;



cubic_spline #(DATA_SIZE_BITS,EXTENTION_BITS, PRECISION_BITS, DEPTH) uut
(
clk,
rst_n,
point_is_extreme,
data_in_available,
first,
last,
extremes,

cubic_spline_out,
first_out,
last_out,
data_out_available
);


initial begin


clk=1;
rst_n = 1;
first <= 0;
spline_finished <=1;
extremes <=0;
data_in_available <=0;
point_is_extreme <= 0;
last <= 0;
#1 rst_n = 0;
#1 rst_n = 1;
end


always #5 clk = !clk;

initial begin

@(negedge clk);
first <= 1;
data_in_available <=1;
spline_finished<=1;
extremes <= 17420;
point_is_extreme <= 1;
@(negedge clk);
first <= 0;
point_is_extreme <= 0;
extremes <= 0;

@(negedge clk);

@(negedge clk);
extremes <= 17420;
point_is_extreme <= 1;
@(negedge clk);
point_is_extreme <= 0;
extremes <= 0;
@(negedge clk);
extremes <= 0;
@(negedge clk);
extremes <= 0;
@(negedge clk);
extremes <= -10766;
point_is_extreme <= 1;
@(negedge clk);
point_is_extreme <= 0;
extremes <= 0;
@(negedge clk);
extremes <= 0;
@(negedge clk);
extremes <= 17420;
point_is_extreme <= 1;
@(negedge clk);
point_is_extreme <= 0;
extremes <= 0;
@(negedge clk);
extremes <= 0;
@(negedge clk);
extremes <= 17420;
point_is_extreme <= 1;
@(negedge clk);
point_is_extreme <= 0;
extremes <= 0;
@(negedge clk);
extremes <= 0;
@(negedge clk);
extremes <= -10766;
point_is_extreme <= 1;
@(negedge clk);
point_is_extreme <= 0;
extremes <= 0;
@(negedge clk);
extremes <= 0;
@(negedge clk);
extremes <= 0;
@(negedge clk);
extremes <= 17420;
point_is_extreme <= 1;
@(negedge clk);
point_is_extreme <= 0;
extremes <= 0;
@(negedge clk);
extremes <= 0;
@(negedge clk);
extremes <= 17420;
point_is_extreme <= 1;
@(negedge clk);
point_is_extreme <= 0;
extremes <= 0;
@(negedge clk);
extremes <= 0;
@(negedge clk);
extremes <= -10766;
last <=1;
point_is_extreme <= 1;
@(negedge clk);
point_is_extreme <= 0;
data_in_available <=0;
last <= 0;
@(negedge clk);
@(negedge clk);
@(negedge clk);
@(negedge clk);

end



endmodule
