


module round 

	//////////////////PARAMETERS///////////////////////////

#(
	parameter 
	DATA_SIZE_BITS = 16, 
	PRECISION_BITS = 8
)

	//////////////////INPUTS AND OUTPUTS////////////////////

(
	input signed [(DATA_SIZE_BITS)-1:0] A,
	output 		 [(DATA_SIZE_BITS)-1:0] B
);

	//////////////////COMBINATORIAL////////////////////////

	assign B = (A[PRECISION_BITS-1:0]) >= (1 << PRECISION_BITS-1) ? (A >>> PRECISION_BITS) + 1 : (A >>> PRECISION_BITS);
	
endmodule
