%% CUBIC SPLINE
%  1) The curve pass through all specified data points.
%  2) 1st derivative continuity at interior points.
%  3) 2nd derivative vontinuity at interior points.
%  4) Boundary conditions specified at the free ends.

function cubic_spline = Cubic_spline_LARS(x,y,interval)

nr_splines = length(x)-1;
[y_dd,h] = find_second_derivative_tri_mat_alg(x,y);

[a, b, c ,d] = find_coeficients(y, y_dd, h);
sxi = zeros;
startpoint = interval(1);
endpoint   = interval(length(interval));

 for i = 1:nr_splines-1
     sxi = (startpoint : x(i+1));
     cubic_spline(sxi) = a(i)*(sxi-x(i)).^3 + b(i)*(sxi-x(i)).^2 + c(i)*(sxi-x(i)) + d(i);
     startpoint = x(i+1);
 end
 i = nr_splines;
 sxi = (x(length(x)-1) : endpoint);
 cubic_spline(sxi) = a(i)*(sxi-x(i)).^3 + b(i)*(sxi-x(i)).^2 + c(i)*(sxi-x(i)) + d(i);
end